/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2010-2011 by Meika Sugimoto
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 */

/*
 *		kernel.hΥץå¸V850ѡ
 *
 *  Υ󥯥롼ɥեϡtarget_kernel.hʤޤϡ饤
 *  롼ɤեˤΤߤ饤󥯥롼ɤ롥¾Υե뤫
 *  ľܥ󥯥롼ɤƤϤʤʤ
 */

#ifndef TOPPERS_PRC_KERNEL_H
#define TOPPERS_PRC_KERNEL_H

/*
 *  ץåǥݡȤ뵡ǽ
 */
#define TOPPERS_TARGET_SUPPORT_DIS_INT		/* dis_int򥵥ݡȤ */
#define TOPPERS_TARGET_SUPPORT_ENA_INT		/* ena_int򥵥ݡȤ */


/*
 *  ͥγͥ٤ϰ
 *
 *  TMIN_INTPRIѹ뤳ȤǡɤΥ٥⤤ͥ
 *  ĤΤ򥫡ͥγߤȤ뤫ѹǤ롥
 *
 */
#ifndef TMIN_INTPRI
#define TMIN_INTPRI		(-7)		/* ͥ٤κǾ͡ʺǹ͡*/
#endif /* TMIN_INTPRI */

#define TMAX_INTPRI		(0)		/* ͥ٤κ͡ʺ͡*/

/*
 *	ߤ°
 */
#define TA_POSEDGE		(TA_EDGE)
#define TA_NEGEDGE		UINT_C(0x00000004)
#define TA_BOTHEDGE		UINT_C(0x00000008)

/*
 *  ݡȤ뵡ǽ
 */
#define TOPPERS_SUPPORT_DIS_INT			/* dis_int򥵥ݡȤ */
#define TOPPERS_SUPPORT_ENA_INT			/* ena_int򥵥ݡȤ */

/*
 *  ݡȤ륪֥°
 */

#define TARGET_INTATR       ((TA_POSEDGE | TA_NEGEDGE | TA_BOTHEDGE) | TA_NONKERNEL)
#define TARGET_INHATR       (TA_NONKERNEL)
#define TARGET_TSKATR       (0)
#define TARGET_ISRATR       (TA_NONKERNEL)
#define TARGET_EXCATR       (0)
#define TARGET_MIN_STKSZ    (64)
#define CHECK_STKSZ_ALIGN   (4)

/* åƤλ */
#define CHECK_FUNC_NONNULL  (true)
#define CHECK_STACK_NONNULL (true)
#define CHECK_MPF_NONNULL   (true)

#define CHECK_FUNC_ALIGN    (2)
#define CHECK_STACK_ALIGN   (4)
#define CHECK_MPF_ALIGN     (4)
#define CHECK_MB_ALIGN      (4)

#endif /* TOPPERS_PRC_KERNEL_H */
