/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel  
 * 
 *  Copyright (C) 2010 by Meika Sugimoto
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 */

#ifndef TOPPERS_PRC_SIL_H
#define TOPPERS_PRC_SIL_H

#define PSW_ID_BITPTN	(1U << 5)

#ifndef TOPPERS_MACRO_ONLY

#include "prc_insn.h"

/*
 *  NMI٤Ƥγߤζػ
 */
Inline uint32_t
TOPPERS_disint(void)
{
	/* ߤPSWIDӥåȤ򥻥åȤ */
	volatile uint32_t psw = current_psw();
	set_psw(psw | PSW_ID_BITPTN);
	
    return(psw);
}

/*
 *  NMI٤Ƥγߤε
 */
Inline void
TOPPERS_enaint(uint32_t TOPPERS_psw)
{
	if((TOPPERS_psw & PSW_ID_BITPTN) == 0u)
	{
		set_psw(current_psw() & ~PSW_ID_BITPTN);
	}
}

/*
 *  ߥå֤
 */
#define SIL_PRE_LOC     volatile uint32_t TOPPERS_psw
#define SIL_LOC_INT()   TOPPERS_psw = TOPPERS_disint()
#define SIL_UNL_INT()   TOPPERS_enaint(TOPPERS_psw)

/*
 *  ץåΥǥ
 */

#define SIL_ENDIAN_LITTLE		/* ȥ륨ǥ */

#endif /* TOPPERS_MACRO_ONLY */

#endif	/* TOPPERS_PRC_SIL_H */
